<?php
if ( ! defined('ABSPATH')) {
    exit;
}
$dashboard = admin_url('admin.php?page=tradedoubler');
$products = admin_url('admin.php?page=tradedoubler&tab=products');
$tracking = admin_url('admin.php?page=tradedoubler&tab=tracking');
$settings = admin_url('admin.php?page=tradedoubler&tab=settings');
$products = admin_url('admin.php?page=tradedoubler&tab=products');
$urlLogin = admin_url('admin.php?page=tradedoubler');


require "header.php";

$api = new TradedoublerAPI(get_option('tradedoubler_credentials', ''));
$codes = $api->getVouchers();

$wooCodes = get_posts([
    'post_type' => 'shop_coupon',
    'nopaging'  => 1,
    'orderby'   => 'date'
]);

$removedCodes = [];
foreach ($wooCodes as $ind => $woo_code) {
    $codeName = ($woo_code->post_title);

    $type = ! TradedoublerActions::isCodeUsedOnce($codeName);
    if ( ! $type) {
        continue;
    }

    if(!empty($_POST))
    {
        if(!isset($_POST['voucher'][$codeName])){
            if (($key = array_search($codeName, $removedCodes)) === false) {
                $removedCodes[] = $codeName;
            }
        } else {
            if (($key = array_search($codeName, $removedCodes)) !== false) {
                unset($removedCodes[$key]);
            }
        }
    }
}
if(!empty($_POST)){
    update_option('removed_codes_tradedoubler',$removedCodes);
}

TradedoublerActions::loadCodesIntoPlatform();
$codes = $api->getVouchers();


$all = null;
$notAll = false;
?>
<main class="main">
    <div class="main_container container">
        <div class="main_top">
            <div class="main_welcome">Discount Codes</div>
            <a target="_blank"
               href="https://grow-platform.tradedoubler.com/login"
               class="main_top_button custom_button -manage">
                Manage
            </a>
            <a target="_blank"
               href="<?= admin_url('/edit.php?post_type=shop_coupon') ?>"
               class="main_top_button custom_button -desktop">
                <img alt="plus"
                     src="<?= TRADEDOUBLER_URI ?>/assets/images/plus.svg">
                New Discount Code
            </a>
            <a target="_blank"
               href="<?= admin_url('/edit.php?post_type=shop_coupon') ?>"
               class="main_top_button custom_button -mobile">
                <img alt="settings"
                     src="<?= TRADEDOUBLER_URI ?>/assets/images/settings.svg">
            </a>
        </div>
        <div class="main_top_text">
            Discount codes are retrieved automatically for your convenience.
            Turn them on to share them with your affiliates or
            sign in to the platform to edit these settings.
        </div>
        <div class="main_top_text" style="display: flex;">
            Toggle all&nbsp;&nbsp;
            <input  autocomplete="off" id="discount-zz"
                    type="checkbox"
                    class="discount_toggle_input">
            <label for="discount-zz" class="discount_toggle_label">
                <div class="discount_toggle_switch"></div>
            </label>
        </div>
        <form method="post" id="tracking-form" class="discount_table sorting_table" novalidate>
            <input type="hidden" name="action" value="update_voucher">
            <table>
                <tr>
                    <td class="sorting_table_item" data-order="upDown"
                        data-type="text">
                        <div class="discount_flex">
                            Voucher Code <img class="discount_sort"
                                              src="<?= TRADEDOUBLER_URI ?>/assets/images/chevron-upDown.svg">
                        </div>
                    </td>
                    <td class="sorting_table_item" data-order="upDown"
                        data-type="text">
                        <div class="discount_flex">
                            Description <img class="discount_sort"
                                             src="<?= TRADEDOUBLER_URI ?>/assets/images/chevron-upDown.svg">
                        </div>
                    </td>
                    <td class="sorting_table_item" data-order="upDown"
                        data-type="text">
                        <div class="discount_flex">
                            Discount <img class="discount_sort"
                                          src="<?= TRADEDOUBLER_URI ?>/assets/images/chevron-upDown.svg">
                        </div>
                    </td>
                    <td class="sorting_table_item" data-order="upDown"
                        data-type="text">
                        <div class="discount_flex">
                            Type <img class="discount_sort"
                                      src="<?= TRADEDOUBLER_URI ?>/assets/images/chevron-upDown.svg">
                        </div>
                    </td>
                    <td>
                        Date Range
                    </td>
                    <td class="sorting_table_item" data-order="upDown"
                        data-type="date">
                        <div class="discount_flex">
                            Creation Date <img class="discount_sort"
                                               src="<?= TRADEDOUBLER_URI ?>/assets/images/chevron-upDown.svg">
                        </div>
                    </td>
                    <td>
                        Commission
                    </td>
                    <td>
                        Status
                    </td>
                    <td>

                    </td>
                </tr>
                <?php foreach ($wooCodes as $ind => $woo_code) {
                    $codeNameRaw = ($woo_code->post_title);
                    $codeName = mb_strtoupper($woo_code->post_title);

                    $type      = !TradedoublerActions::isCodeUsedOnce($codeNameRaw);
                    if(!$type)
                        continue;

                    $description = $woo_code->post_excerpt;
                    $meta        = get_post_meta($woo_code->ID);

                    $discType  = '';
                    $discValue = $meta['coupon_amount'][0];


                    $code       = null;
                    $codeStart  = '';
                    $codeEnd    = '';
                    $codeUpdate = date('d/m/Y H:i',strtotime($woo_code->post_date));

                    foreach($codes as $singleCode)
                    {
                        if(isset($singleCode['code']) && $singleCode['code'] == $codeNameRaw)
                        {
                            $code = $singleCode;
                            break;
                        }
                    }

                    if($code){
                        $codeStart = (date('d/m/Y H:i',
                            ($code['startDate'] / 1000)));
                        $codeEnd = date('d/m/Y H:i',
                            ($code['endDate'] / 1000));
                        $codeUpdate = date('d/m/Y H:i',
                            ($code['updateDate'] / 1000));
                    }

                    $useType =  $meta['discount_type'][0] == 'percent';

                    if ($useType != 1) {
                        $discType = sprintf("%s %s off everything", $discValue,
                            get_woocommerce_currency());
                    }
                    if ($useType == 1) {
                        $discType = sprintf("%s%% off everything",
                            $discValue);
                    }

                    $code['active'] = true;
                    $removedCodes = get_option('removed_codes_tradedoubler',[]);
                    if(in_array($codeNameRaw, $removedCodes))
                        $code['active'] = false;

                    $isLive = true;

                    if($all === null)
                        $all = $code['active'];
                    elseif($all != $code['active'])
                        $notAll = true;
                    ?>
                    <tr>
                        <td><?= $codeName ?></td>
                        <td><?= $description ?></td>
                        <td><?= $discType ?></td>
                        <td><?= $type ? 'Generic' : 'Exclusive' ?></td>
                        <td><?= $codeStart . ' - <br>' . $codeEnd ?></td>
                        <td><?= $codeUpdate ?></td>
                        <td>Default</td>
                        <td title="<?= TradedoublerActions::get_referral_coupon_error($codeNameRaw) ?>">
                            <div class="discount_status <?= TradedoublerActions::is_referral_coupon_valid($codeNameRaw)
                                ? '-green' : '-red' ?>">
                                <?= TradedoublerActions::is_referral_coupon_valid($codeNameRaw)
                                    ? 'Live' : 'Expired' ?>
                            </div>
                        </td>
                        <td>
                            <input autocomplete="off" id="discount-<?= $ind ?>"
                                   type="checkbox" name="voucher[<?= $codeNameRaw ?>]"
                                   class="discount_toggle_input"
                                <?= $code['active'] ? 'checked' : '' ?>>
                            <label for="discount-<?= $ind ?>" class="discount_toggle_label">
                                <div class="discount_toggle_switch"></div>
                            </label>
                        </td>
                    </tr>
                <?php } ?>
                <tr class="discount_table_bg table_bg"></tr>
            </table>
        </form>
    </div>
</main>
<footer class="footer -white">
    <div class="footer_container container -main">
        <a href="<?= $dashboard ?>" class="custom_button -whiteRed -px-32">Cancel</a>
        <button type="submit" form="tracking-form" class="custom_button">Save
        </button>
    </div>
</footer>
<script>
    let el = document.querySelector('#discount-zz');
    if(el)
    {
        <?php if(!$notAll) { ?>
        el.checked = <?= $all ? 'true' : 'false' ?>;
        <?php } ?>
        el.addEventListener('change', function(){
            document.querySelectorAll('table .discount_toggle_input').forEach((e) => {
                e.checked = el.checked;
            })
        })
    }
</script>