<?php
if ( ! defined('ABSPATH')) {
    exit;
}
$products = admin_url('admin.php?page=tradedoubler&tab=products');
$codes    = admin_url('admin.php?page=tradedoubler&tab=codes');
$tracking = admin_url('admin.php?page=tradedoubler&tab=tracking');
$settings = admin_url('admin.php?page=tradedoubler&tab=settings');
$products = admin_url('admin.php?page=tradedoubler&tab=products');
$urlLogin = admin_url('admin.php?page=tradedoubler');
require "header.php";

$api = new TradedoublerAPI(get_option('tradedoubler_credentials', ''));

$feeds = $api->getProductFeeds();
if ( ! is_array($feeds)) {
    $feeds = [];
}
$id = TradedoublerActions::getFeedDefaultId();

if (empty($feeds)) {
    $feeds = [];
}

?>
<main class="main">
    <div class="main_container container">
        <div class="main_top">
            <div class="main_welcome">Products</div>
            <a target="_blank"
               href="https://grow-platform.tradedoubler.com/login"
               class="main_top_button custom_button -desktop">
                <img alt="settings icon"
                     src="<?= TRADEDOUBLER_URI ?>/assets/images/settings.svg">
                Manage Product Feed
            </a>
            <a target="_blank"
               href="https://grow-platform.tradedoubler.com/login"
               class="main_top_button custom_button -mobile">
                <img alt="settings icon"
                     src="<?= TRADEDOUBLER_URI ?>/assets/images/settings.svg">
            </a>
        </div>
        <div class="main_top_text">
            Sign in to the platform to edit these settings.
        </div>
        <div class="products_table sorting_table">
            <?php if (empty($feeds)) { ?>
                We are busy creating and processing your product feed. It will be available to your publishers within the next 24 hours
            <?php } elseif ( ! empty($feeds)) { ?>
                <table>
                    <tr>
                        <td class="sorting_table_item" data-order="upDown"
                            data-type="text">
                            <div class="products_flex">
                                Feed Name <img alt="feed name sort"
                                               class="products_sort"
                                               src="<?= TRADEDOUBLER_URI ?>/assets/images/chevron-upDown.svg">
                            </div>
                        </td>
                        <td class="sorting_table_item" data-order="upDown"
                            data-type="date">
                            <div class="products_flex">
                                Last Updated <img alt="Updated name sort"
                                                  class="products_sort"
                                                  src="<?= TRADEDOUBLER_URI ?>/assets/images/chevron-upDown.svg">
                            </div>
                        </td>
                        <td class="sorting_table_item" data-order="upDown"
                            data-type="number">
                            <div class="products_flex">
                                Products <img alt="Products name sort"
                                              class="products_sort"
                                              src="<?= TRADEDOUBLER_URI ?>/assets/images/chevron-upDown.svg">
                            </div>
                        </td>
                        <td class="sorting_table_item" data-order="upDown"
                            data-type="date">
                            <div class="products_flex">
                                Active <img alt="active name sort"
                                            class="products_sort"
                                            src="<?= TRADEDOUBLER_URI ?>/assets/images/chevron-upDown.svg">
                            </div>
                        </td>
                        <td class="sorting_table_item" data-order="upDown"
                            data-type="date">
                            <div class="products_flex">
                                <img alt="active name sort"
                                     class="products_sort"
                                     src="<?= TRADEDOUBLER_URI ?>/assets/images/chevron-upDown.svg">
                            </div>
                        </td>
                    </tr>
                    <?php foreach ($feeds as $feed) {
                        ?>
                        <tr>
                            <td>
                                <?= str_replace(['_Active:N', '_Active:Y'], '',
                                    $feed['name']) ?>
                            </td>
                            <td>
                                <?= $feed['lastModifiedTime'] === '-'
                                    ? '-'
                                    : date('d/m/Y H:i',
                                        strtotime($feed['lastModifiedTime'])) ?>
                            </td>
                            <td>
                                <?= (int)$feed['numberOfProducts'] ?>
                            </td>
                            <td>
                                <?= $feed['active'] ? 'active' : 'inactive'; ?>
                            </td>
                            <td>
                                <?= (int)$feed['feedId'] != (int)$id
                                    ? "<div class='discount_status -red'>Legacy</div>"
                                    : "<div class='discount_status -green'>Auto</div>" ?>
                            </td>
                        </tr>
                    <?php } ?>
                    <tr class="products_table_bg table_bg"></tr>
                </table>
            <?php } ?>
        </div>
    </div>
</main>